=== debian/changelog ===
ros-melodic-behaviortree-cpp-v3 (3.5.3-1stretch) stretch; urgency=high

  * fix issue #228 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/228> . Retry and Repeat node need to halt the child
  * better tutorial
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 09 Sep 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.5.2-1stretch) stretch; urgency=high

  * fix warning and follow coding standard
  * docs: Small changes to tutorial 02 (#225 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/225>)
    Co-authored-by: Valerio Magnago <mailto:valerio.magnago@fraunhofer.it>
  * Merge branch 'master' of https://github.com/BehaviorTree/BehaviorTree.CPP
  * tutorial 1 fixed
  * decreasing warning level to fix issue #220 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/220>
  * fix compilation
  * Allow BT factory to define clock source for TimerQueue/TimerNode (#215 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/215>)
    * Allow BT factory to define clock source for TimerQueue/TimerNode
    * Fix unit tests
    Co-authored-by: Cam Fulton <mailto:cfulton@symbotic.com>
    Co-authored-by: Davide Faconti <mailto:davide.faconti@gmail.com>
  * Added delay node and wait for enter keypress node (#182 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/182>)
    * Added delay node and wait for enter press node
    * Fixed unsigned int to int conversion bug
    * Added a new timer to keep a track of delay timeout and return RUNNING in the meanwhile
    * Removed wait for keypress node
    * Review changes suggested by gramss
    Co-authored-by: Indraneel Patil <mailto:indraneel.p@greyorange.com>
  * Update SequenceNode.md (#211 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/211>)
  * add failure threshold to parallel node with tests (#216 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/216>)
  * Update tutorial_05_subtrees.md
    I believe that the API has been updated. Reflecting the same in this tutorial.
  * Contributors: Aayush Naik, Davide Faconti, Indraneel Patil, Renan Salles, Valerio Magnago, Wuqiqi123, fultoncjb

 -- Davide Faconti <davide.faconti@gmail.com>  Tue, 01 Sep 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.5.1-1stretch) stretch; urgency=high

  * trying to fix compilation in eloquent  Minor fix on line 19
  * Update README.md
  * more badges
  * readme updated
  * fix ros2 compilation?
  * move to github actions
  * replace dot by zero in boost version (#197 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/197>)
  * Always use nonstd::string_view for binary compatibility (fix issue #200 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/200>)
  * Adding ForceRunningNode Decorator (#192 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/192>)
  * updated doc
  * Add XML parsing support for custom Control Nodes (#194 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/194>)
  * Fix typo
  * [Windows] Compare std::type_info objects to check type. (#181 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/181>)
  * Fix pseudocode for ReactiveFallback. (#191 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/191>)
  * Contributors: Aayush Naik, Darío Hereñú, Davide Faconti, Francisco Martín Rico, G.Doisy, Sarathkrishnan Ramesh, Sean Yen, Ting Chang

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 10 Jun 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.5.0-1stretch) stretch; urgency=high

  * added IfThenElse and  WhileDoElse
  * issue #190 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/190>
  * unit test added
  * reverting to a better solution
  * RemappedSubTree added
  * Fix issue #188 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/188>
  * added function const std::string& key (issue #183 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/183>)
  * Contributors: Davide Faconti, mailto:daf@blue-ocean-robotics.com
  * added IfThenElse and  WhileDoElse
  * issue #190 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/190>
  * unit test added
  * reverting to a better solution
  * RemappedSubTree added
  * Fix issue #188 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/188>
  * added function const std::string& key (issue #183 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/183>)
  * Contributors: Davide Faconti, mailto:daf@blue-ocean-robotics.com

 -- Davide Faconti <davide.faconti@gmail.com>  Wed, 13 May 2020 22:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.1.1-1stretch) stretch; urgency=high

  * fix samples compilation (hopefully)
  * Contributors: Davide Faconti

 -- Davide Faconti <davide.faconti@gmail.com>  Sat, 09 Nov 2019 23:00:00 -0000

ros-melodic-behaviortree-cpp-v3 (3.1.0-1stretch) stretch; urgency=high

  * Error message corrected
  * fix windows and mingw compilation (?)
  * Merge pull request #70 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/70> from Masadow/patch-3
    Added 32bits compilation configuration for msvc
  * make Tree non copyable
  * fix #114 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/114>
  * Merge branch 'master' of https://github.com/BehaviorTree/BehaviorTree.CPP
  * critical bug fix affecting AsyncActionNode
    When a Tree is copied, all the thread related to AsyncActionNode where
    invoked.
    As a consequence, they are never executed, despite the fact that the
    value RUNNING is returned.
  * Fix issue #109 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/109>
  * fix #111 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/111>
  * Merge pull request #108 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/108> from daniel-serrano/add-RobMoSys-acknowledgement
    Add robmosys acknowledgement
  * Add robomosys acknowledgement as requested
  * Add robomosys acknowledgement as requested
  * added more comments (issue #102 <https://github.com/BehaviorTree/BehaviorTree.CPP/issues/102>)
  * Update README.md

