=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 ######################################################
 # TESTS
 
-include_directories(include)
+include_directories(${PROJECT_SOURCE_DIR}/3rdparty include)
 
 set(BT_TESTS
   src/action_test_node.cpp
@@ -13,15 +13,27 @@
   gtest_factory.cpp
   gtest_decorator.cpp
   gtest_blackboard.cpp
+  gtest_blackboard_precondition.cpp
   gtest_ports.cpp
   navigation_test.cpp
   gtest_subtree.cpp
   gtest_switch.cpp
+  gtest_wakeup.cpp
 )
 
-if (BT_COROUTINES)
-    list(APPEND BT_TESTS  gtest_coroutines.cpp)
+if( ZMQ_FOUND )
+    LIST( APPEND BT_TESTS gtest_logger_zmq.cpp)
 endif()
+
+if( BT_COROUTINES )
+    LIST( APPEND BT_TESTS gtest_coroutines.cpp)
+endif()
+
+#if(ament_cmake_FOUND OR catkin_FOUND)
+#    # This test requires gmock. Since we don't have a uniform way to include
+#    # gmock for non-users, it is turned of when build without ros.
+#    list(APPEND BT_TESTS gtest_async_action_node.cpp)
+#endif()
 
 if(ament_cmake_FOUND AND BUILD_TESTING)
 
@@ -42,17 +54,20 @@
                                                         ${catkin_LIBRARIES})
     target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include)
 
-elseif(GTEST_FOUND AND BUILD_UNIT_TESTS)
+elseif(BUILD_UNIT_TESTS)
 
     enable_testing()
 
     add_executable(${BEHAVIOR_TREE_LIBRARY}_test ${BT_TESTS})
     target_link_libraries(${PROJECT_NAME}_test ${BEHAVIOR_TREE_LIBRARY}
-                                                bt_sample_nodes
-                                                ${GTEST_LIBRARIES}
-                                                ${GTEST_MAIN_LIBRARIES})
+                                                bt_sample_nodes gtest gtest_main)
     target_include_directories(${BEHAVIOR_TREE_LIBRARY}_test PRIVATE gtest/include ${GTEST_INCLUDE_DIRS})
 
-    add_test(BehaviorTreeCoreTest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${BEHAVIOR_TREE_LIBRARY}_test)
+    add_custom_command(TARGET ${BEHAVIOR_TREE_LIBRARY}_test POST_BUILD
+        COMMAND ${CMAKE_COMMAND} -E copy_directory
+            ${CMAKE_SOURCE_DIR}/tests/trees
+            trees)
+
+    add_test(BehaviorTreeCoreTest ${BEHAVIOR_TREE_LIBRARY}_test)
 
 endif()
